/*
 * in226.c
 *
 *  Created on: 2014/08/09
 *      Author: king
 */
#include  <msp430g2452.h>
#include "std_type.h"

#include "ina226.h"
#include "i2c_functions.h"

/** ina226_init()  INA226
 *  1)Zbgs
 *  2)AVGrbgݒ
 *  3)Calibrationݒ@ZXRZol
 *  param: Ȃ
 *  return: Ȃ
 */
void ina226_init(void){
	ina226_write( INA226_REG_CONFIGURATION , 0x8000 );	// Zbgs
	uint16_t con = ina226_read();						// ConfigurationWX^lǂݍ
	con &= 0xf1ff;										// AVG bit̂0ɂ
	con |= INA226_AVG4 << 9;
	ina226_write( INA226_REG_CONFIGURATION , con );		// AVG bit setting
	ina226_write( INA226_REG_CALIBRATION   , INA226_CALIBRATION );
}
/** ina226_voltage()
 * 	VBUS d擾
 * 	param : Ȃ
 * 	return: mVPʂ̓dl
 */
uint32_t ina226_voltage( void ){
	ina226_set_pointer( INA226_REG_BUS_VOLTAGE );	//WX^I
	uint16_t val = ina226_read();					//f[^擾
//	uint32_t ret = (uint32_t)val * 125UL / 100UL;	//1LSB=1.25mV
	uint32_t ret = (uint32_t)val * 125 / 100 ;		//1LSB=1.25mV
	return ( ret );
}

/** ina226_current()
 * 	dl擾
 *  param : Ȃ
 *  return: mAPʂ̓dl
 */
uint32_t ina226_current( void ){
	ina226_set_pointer( INA226_REG_CURRENT );		// WX^I
	uint16_t ret = ina226_read();					// f[^擾
	if ( ret & 0x8000 ) ret = 0U;					// }CiX͋I0
	return ( ret );
}

/** ina226_power()
 * 	d͎擾
 *  param : Ȃ
 *  return: mWPʂ̓d͒l
 */
uint32_t ina226_power( void ){
	ina226_set_pointer( INA226_REG_POWER );			// WX^I
	uint16_t val = ina226_read();					// f[^擾
	if ( val & 0x8000 ) val = 0U;					// }CiX͋I0
	uint32_t ret = (uint32_t)val * 25UL;			// 1step=25mW
	return ( ret );
}

/** ina226_set_pointer( reg )
 * 	|C^ݒ
 *  param : reg WX^ԍ
 *		0x00 : INA226_REG_CONFIGURATION
 *		0x01 : INA226_REG_SHUNT_VOLTAGE
 *		0x02 : INA226_REG_BUS_VOLTAGE
 *		0x03 : INA226_REG_POWER
 *		0x04 : INA226_REG_CURRENT
 *		0x05 : INA226_REG_CALIBRATION
 *		0x06 : INA226_REG_MASK_ENABLE
 *		0x07 : INA226_REG_ALERT_LIMIT
 *		0xff : INA226_REG_DIE_ID
 *  return: Ȃ
@*/
void ina226_set_pointer( uint8_t reg ){
	i2c_start( INA226_ADDR , I2C_RW_WRITE );
	i2c_send( reg );
	i2c_stop();
}

/**@ina226_write( data )
 * 	WX^
 *  param : reg WX^ԍ
 *		0x00 : INA226_REG_CONFIGURATION
 *		0x05 : INA226_REG_CALIBRATION
 *		0x06 : INA226_REG_MASK_ENABLE
 *		0x07 : INA226_REG_ALERT_LIMIT
 *  param : data ݃f[^
 *  return: Ȃ
 */
void ina226_write( uint8_t reg ,uint16_t data ){
	i2c_start( INA226_ADDR , I2C_RW_WRITE );
	i2c_send( reg );
	i2c_send( (uint8_t)( ( data & 0xff00 ) >> 8 ) );
	i2c_send( (uint8_t)( data & 0xff ) );
	i2c_stop();
}

/** ina226_read()
 * 	WX^ǂݏo
 *  param : Ȃ
 *  return: Ȃ
 */
uint16_t ina226_read( void ){
	uint8_t h ,l;

	i2c_start( INA226_ADDR ,I2C_RW_READ );
	h = i2c_receive();
	l = i2c_receive();
	i2c_stop();
	return ( (uint16_t)h << 8 | l );
}

