/**
 * ina226.h
 *
 *  Created on: 2014/08/09
 *      Author: king
 */

#ifndef INA226_H_
#define INA226_H_

/** INA226 VgRl`imj
 */
#define INA226_SHUNT_R	10

/** CalibrationRegisterݒl`(XP[Op)
 *  Current = ShuntVoltage * CalibrationRegister
 */
#define INA226_CALIBRATION ( 2.5 * 2048 / INA226_SHUNT_R )

/** I2CX[uAhX`
 *  A1,A0[q̓dɂ16ނ̃AhXݒ\(DatasheetQ)
 */
#define INA226_ADDR		0x40	// A1=GND ,A0=GND

/** INA226 WX^ԍ`
 */
#define INA226_REG_CONFIGURATION	0x00	// Zbg̏l 0x4127 ɐݒ肳Ă
#define INA226_REG_SHUNT_VOLTAGE	0x01	// dl = Ǐol(t16bit) ~ 2.5V
#define INA226_REG_BUS_VOLTAGE		0x02	// dl = Ǐol(16bit) ~ 1.25mV
#define INA226_REG_POWER			0x03
#define INA226_REG_CURRENT			0x04
#define INA226_REG_CALIBRATION		0x05
#define INA226_REG_MASK_ENABLE		0x06
#define INA226_REG_ALERT_LIMIT		0x07
#define INA226_REG_DIE_ID			0xff

/** ϒlvZp̃Tv`
 *  Configuration RegisterAVDrbg
 */
#define INA226_AVG1		0
#define INA226_AVG4		1
#define INA226_AVG16	2
#define INA226_AVG64	3
#define INA226_AVG128	4
#define INA226_AVG256	5
#define INA226_AVG512	6
#define INA226_AVG1024	7

/** ֐vg^Cv錾
 */
void ina226_init( void );
void ina226_set_pointer( uint8_t reg );
void ina226_write( uint8_t reg ,uint16_t data );
uint16_t ina226_read( void );
uint32_t ina226_power( void );
uint32_t ina226_voltage( void );
uint32_t ina226_current( void );

#endif /* INA226_H_ */
